/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: gpshared.h                                                      |
| DESCRIPTION: Function prototypes for gpshared.c.                      |
|                                                                       |       
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/


unsigned long MyRand(void);  /*funcdef*/
unsigned long MyMaxRand(void);  /*funcdef*/
unsigned long MySrand(unsigned long my_seed);  /*funcdef*/
unsigned long GetMyRand(void); /*funcdef*/
unsigned long PM_Rand(void);  /*funcdef*/
unsigned long PM_MaxRand(void);  /*funcdef*/
unsigned long PM_Srand(unsigned long my_seed);  /*funcdef*/
unsigned long GetPMRand(void); /*funcdef*/
unsigned long Randu_Rand(void);  /*funcdef*/
unsigned long Randu_MaxRand(void);  /*funcdef*/
unsigned long Randu_Srand(unsigned long my_seed);  /*funcdef*/
unsigned long GetRanduRand(void); /*funcdef*/

void SetSeed(Population *pop,  unsigned long s  );  /*funcdef - dgpc - SetSeed*/
unsigned long GetSeed(Population * pop);  /*funcdef - dgpc - GetSeed*/
float GaussianNoise(float mean, float sigma );  /*funcdef - dgpc - GaussianNoise*/
float ParkMillerRandomizer(void);  /*funcdef - dgpc - ParkMillerRandomizer*/
float RandomFloat( float f  );   /*   0 <=  RandomFloat() < f  */ /*funcdef - dgpc - RandomFloat*/
int RandomInt(   int i  );     /* 0 <= RandomInt() < i   */ /*funcdef - dgpc - RandomInt*/
void CreateIndividual(Individual * ind);  /*funcdef - dgpc - CreateIndividual*/
void CopyIndividual(Individual * ind1, Individual * ind2);  /*funcdef - dgpc - CopyIndividual*/
void CopyTree(Branch * br1, Branch * br2);  /*copies br1 into br2*/ /*funcdef - dgpc - CopyTree*/
int GetFuncNumber(char * str,Population * pop);

