/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: pentstub.h                                                      |
| DESCRIPTION: Function prototypes for pentstub.c.                      |
|                                                                       |       
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/


void MainGPLoop(Population * popptr, StartupInfo * paramptr,time_t clck); /*MainGPLoop- funcdef - */
int gpentTerminationQuery(int gen); /*funcdef*/
void PreparePrimedInd(Individual * ind,Population *pop); /*funcdef*/
void ReadPrimedIndividuals(Population *pop); /*funcdef*/
void CreateRandomConstants(Population *pop); /*funcdef*/
void GetPerpetualNumber(int * pn); /*funcdef - startup - GetPerpetualNumber*/
void DoRandoms(Population *pop,int perpetual_number) ; /*funcdef - startup - DoRandoms*/
void DoWelcomeMessage(void); /*funcdef - startup - DoWelcomeMessage*/
void  WriteInfoToOutputFile(Population *pop,              /*funcdef - startup - WriteInfoToOutputFile*/ 
                           char * out_put_file_name,         /*funcdef - startup - WriteInfoToOutputFile*/ 
                           int perpetual_number,          /*funcdef - startup - WriteInfoToOutputFile*/   
                           char * timestr);           /*funcdef - startup - WriteInfoToOutputFile*/   
void ReadInputFile(char * filename,Population * spop);  /*funcdef - startup - ReadInputFile*/
void WriteToArchive(Population *pop,int perpetual_number, char * str); /*funcdef - startup - WriteToArchive*/
void	ReportToFile(int counter,    /*funcdef - startup - ReportToFile*/
                       int run_num,     /*funcdef - startup -ReportToFile*/
                       FILE * ofp);      /*funcdef - startup -ReportToFile*/
void	ReportToScreen(int counter,int run_num);   /*funcdef - startup - ReportToScreen*/
void PrintIndividual(Individual * ind, FILE * ofp); /*funcdef - dgpc - PrintIndividual*/
void ReadIndividual(FILE * ofp, Individual * ind); /*funcdef - dgpc - ReadIndividual */
int GoToInFile(FILE * ofp, char * str);   /*funcdef - dgpc - GoToInFile*/
void blanks(FILE *f, int n);  /*funcdef - dgpc - blanks*/
int disspace(char ch);  /*funcdef - dgpc - disspace*/
void GetNextToken(char *buf, FILE *f); /*funcdef - dgpc - GetNextToken*/
int  ReadBranch(Branch *br, FILE *f, int index); /*funcdef - dgpc - ReadBranch*/
int FindConstantInTables(GTYPE temp, int *constant_num); /*funcdef - dgpc - FindConstantInTable*/
int PrintTree(Branch * br, int index, int depth,  FILE *f, int *counter); /*funcdef - dgpc - PrintTree*/
void WriteBranch(Branch * br, FILE *f);  /*funcdef - dgpc - WriteBranch*/
void PrintFunctionTable(FILE * ofp,Population * pop); /*funcdef - dgpc - PrintFunctionTable*/
int LookupFunctionName(char *buf);  /*funcdef - dgpc - CopySubtree*/
